unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
TmyThread = class (TThread)
private
X, Y, Color : Integer;
protected
procedure Execute; override;
procedure Paint;
end;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    PT ,PT_1: TMyThread;

    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  mass:array of array of byte;

implementation

{$R *.dfm}

procedure TMyThread.Execute;
begin
Randomize;
X:=0;Y:=0;
repeat
X:=Random(Form1.Width);
Y:=Random(Form1.Height);
Color:=Random($FFFFFFFF);
Synchronize (Paint);
until Terminated;
end;


procedure TMyThread.Paint;
begin
with Form1.Canvas do begin
{ ,       :-)}
Pixels[X,Y-1]:=Color;
Pixels[X+1,Y]:=Color;
Pixels[X-1,Y]:=Color;
Pixels[X,Y+1]:=Color;
Pixels[X,Y]:=Color;
end;
end;


//      :

procedure TForm1.Button1Click(Sender: TObject);
begin
Button1.Enabled:=False;
Button2.Enabled:=True;
PT:=TMyThread.Create(false); //   
PT_1:=TMyThread.Create(false);
//Pt.Priority:=tpTimeCritical;     //   :)))
//Pt_1.Priority:=tpTimeCritical;
SetThreadAffinityMask(PT.Handle,1); //   2 
SetThreadAffinityMask(PT_1.Handle,2);
//SetThreadIdealProcessor(pt.Handle,1);
//SetThreadIdealProcessor(pt_1.Handle,2);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Button1.Enabled:=True;
Button2.Enabled:=False;
PT.Free; //  
PT_1.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
SetThreadAffinityMask(PT.Handle,1);  //       
SetThreadAffinityMask(PT_1.Handle,1);
//SetThreadIdealProcessor(pt.Handle,1);
//SetThreadIdealProcessor(pt_1.Handle,1);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
SetThreadAffinityMask(PT.Handle,2);    //     
SetThreadAffinityMask(PT_1.Handle,2);
//SetThreadIdealProcessor(pt.Handle,2);
//SetThreadIdealProcessor(pt_1.Handle,2);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
SetThreadAffinityMask(PT.Handle,1);      //     
SetThreadAffinityMask(PT_1.Handle,2);
//SetThreadIdealProcessor(pt.Handle,1);
//SetThreadIdealProcessor(pt_1.Handle,2);
end;

end.
